module.exports = {
    plugins: ["react"],
    rules: {
        //
        // eslint-plugin-react
        //
        // React specific linting rules for ESLint
        //
        "react/jsx-max-props-per-line": 2,
        "react/jsx-closing-bracket-location": 2,
        "react/display-name": 0, // Prevent missing displayName in a React component definition
        "react/jsx-boolean-value": [2, "always"], // Enforce boolean attributes notation in JSX
        "react/jsx-no-undef": 2, // Disallow undeclared variables in JSX
        "react/jsx-sort-prop-types": 0, // Enforce propTypes declarations alphabetical sorting
        "react/jsx-sort-props": 2, // Enforce props alphabetical sorting
        "react/jsx-uses-react": 2, // Prevent React to be incorrectly marked as unused
        "react/jsx-uses-vars": 2, // Prevent variables used in JSX to be incorrectly marked as unused
        "react/jsx-tag-spacing": [2, {
             "closingSlash": "never",
             "beforeSelfClosing": "always",
             "afterOpening": "never"
         }], // Enfore space before closing tag
        "react/no-did-mount-set-state": 2, // Prevent usage of setState in componentDidMount
        "react/no-did-update-set-state": 2, // Prevent usage of setState in componentDidUpdate
        "react/no-direct-mutation-state": 2,
        "react/no-multi-comp": [2, { "ignoreStateless": true }], // Prevent multiple component definition per file
        "react/no-unknown-property": 2, // Prevent usage of unknown DOM property
        "react/no-unescaped-entities": 2,
        "react/prop-types": [0, {"ignore": ["children", "dispatch", "onFormChange"]}], // Prevent missing props validation in a React component definition
        "react/react-in-jsx-scope": 2, // Prevent missing React when using JSX
        "react/require-extension": 0, // Restrict file extensions that may be required
        "react/self-closing-comp": 2, // Prevent extra closing tags for components without children
        "react/jsx-wrap-multilines": 2, // Prevent missing parentheses around multilines JSX
        "react/sort-comp": 2, // Enforce component methods order (sort-comp)
        "react/no-string-refs": 2, // Enforce no depricated way of using refs
        "react/no-danger": 2, // prevent dangerouslySetInnerHTML
        "react/no-deprecated": 2, // prevent deprecated methods
        "react/no-is-mounted": 2,
        "react/prefer-es6-class": 2, // yep
        "react/prefer-stateless-function": [2, { "ignorePureComponents": false }],
        "react/jsx-indent-props": [2, 4],
        "react/jsx-no-bind": ["error", {"allowArrowFunctions": true}],
        "react/jsx-curly-spacing": [2, "never"],
        "react/jsx-pascal-case": 2,
    }

}
